using Exferia_Agenda._0_Modelos;
using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Agenda;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Exferia_Agenda._3_Vistas.Listados
{
    public class ABS_Listado_AGD_Citas_CentroInformacion : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_AGD_Citas_CentroInformacion()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_AGD_Citas_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_AGD_Citas_Listado_Modelo.id), "id", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));

            //codigo
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_AGD_Citas_Listado_Modelo.codigo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_AGD_Citas_Listado_Modelo.codigo), "Código", Enumerados.G_ENUM_TIPOSDATOS.LONG_TEXT, false, 90, true, true, true, false, "", null));

            //descripcion
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_AGD_Citas_Listado_Modelo.descripcion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_AGD_Citas_Listado_Modelo.descripcion), "Descripción", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 400, true, true, true, false, "", null));

            //avisado
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_AGD_Citas_Listado_Modelo.avisado), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_AGD_Citas_Listado_Modelo.avisado), "Avisado", Enumerados.G_ENUM_TIPOSDATOS.BOOLEAN, false, 130, true, false, true, false, "", null));

            //fecha
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_AGD_Citas_Listado_Modelo.Fecha), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_AGD_Citas_Listado_Modelo.Fecha), "Fecha", Enumerados.G_ENUM_TIPOSDATOS.DATETIME, false, 110, true, false, true, false, "", null));

            //HoraInicio
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_AGD_Citas_Listado_Modelo.HoraInicio), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_AGD_Citas_Listado_Modelo.HoraInicio), "Hora inicio", Enumerados.G_ENUM_TIPOSDATOS.HORASIMPLE, false, 110, true, false, true, false, "", null));

            //HoraFin
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_AGD_Citas_Listado_Modelo.HoraFin), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_AGD_Citas_Listado_Modelo.HoraFin), "Hora fin", Enumerados.G_ENUM_TIPOSDATOS.HORASIMPLE, false, 110, true, false, true, false, "", null));

            //Delegacion
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_DELEGACION = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_AGD_Citas_Listado_Modelo.idDelegacion), nameof(GEN_Delegaciones), nameof(GEN_Delegaciones.id), nameof(GEN_Delegaciones.codigo), nameof(GEN_Delegaciones.descripcion), nameof(GEN_Delegaciones.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_AGD_Citas_Listado_Modelo.Delegacion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_AGD_Citas_Listado_Modelo.Delegacion), "Delegación", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_DELEGACION));

            //Empresa
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPRESA = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_AGD_Citas_Listado_Modelo.idEmpresa), nameof(GEN_Empresas), nameof(GEN_Empresas.id), nameof(GEN_Empresas.codigo), nameof(GEN_Empresas.descripcion), nameof(GEN_Empresas.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_AGD_Citas_Listado_Modelo.Empresa), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_AGD_Citas_Listado_Modelo.Empresa), "Empresa", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPRESA));

        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }


        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_AGD_CITAS);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_AGD_CITAS + "_CentroInformacion";
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_AGD_Citas_Listado_Modelo.codigo);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
